<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:06 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/doc.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/doc.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/doc.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Abstract base class of all Doc classes. Doc item's are representations of
<a name="line22"></a> * PHP language constructs (class, package, method,...) which have comments
<a name="line23"></a> * and have been processed by this run of PHPDoctor.
<a name="line24"></a> *
<a name="line25"></a> * @package PHPDoctor
<a name="line26"></a> * @abstract
<a name="line27"></a> */
<a name="line28"></a>class Doc {
<a name="line29"></a>
<a name="line30"></a>	/** The name of this construct
<a name="line31"></a>	 *
<a name="line32"></a>	 * @var str
<a name="line33"></a>	 */
<a name="line34"></a>	var $_name = NULL;
<a name="line35"></a>
<a name="line36"></a>	/** Data about the element creamed from the token stream before the object
<a name="line37"></a>	 * for this element was created. This array contains extra data about the
<a name="line38"></a>	 * element that occurs before the element definition in the token stream
<a name="line39"></a>	 * (including doc comment data), it is merged with the objects fields upon
<a name="line40"></a>	 * object completion.
<a name="line41"></a>	 *
<a name="line42"></a>	 * @var mixed[]
<a name="line43"></a>	 */
<a name="line44"></a>	var $_data = NULL; // this must be NULL so set does not nest the arrays when $currentData is assigned
<a name="line45"></a>
<a name="line46"></a>	/** The unprocessed doc comment.
<a name="line47"></a>	 *
<a name="line48"></a>	 * @var str
<a name="line49"></a>	 */
<a name="line50"></a>	var $_docComment = '';
<a name="line51"></a>
<a name="line52"></a>	/** Array of doc tags.
<a name="line53"></a>	 *
<a name="line54"></a>	 * @var tag[]
<a name="line55"></a>	 */
<a name="line56"></a>	var $_tags = array();
<a name="line57"></a>
<a name="line58"></a>	/** Whether parsing is inside this elements curly braces.
<a name="line59"></a>	 *
<a name="line60"></a>	 * @var int
<a name="line61"></a>	 */
<a name="line62"></a>	var $inBody = 0;
<a name="line63"></a>	
<a name="line64"></a>	/** Reference to the root element.
<a name="line65"></a>	 *
<a name="line66"></a>	 * @var rootDoc
<a name="line67"></a>	 */
<a name="line68"></a>	var $_root = NULL;
<a name="line69"></a>	
<a name="line70"></a>	/** Setter method.
<a name="line71"></a>	 *
<a name="line72"></a>	 * @param str member Name of the member to set
<a name="line73"></a>	 * @param mixed value The value to set member to
<a name="line74"></a>	 * @return bool
<a name="line75"></a>	 */
<a name="line76"></a>	function set($member, $value)
<a name="line77"></a>    {
<a name="line78"></a>		$member = '_'.$member;
<a name="line79"></a>		$members = get_object_vars($this);
<a name="line80"></a>		if (array_key_exists($member, $members)) {
<a name="line81"></a>			if (is_array($this->$member)) {
<a name="line82"></a>				$this->{$member}[] = $value;
<a name="line83"></a>			} else {
<a name="line84"></a>				$this->$member = $value;
<a name="line85"></a>			}
<a name="line86"></a>			return TRUE;
<a name="line87"></a>		}
<a name="line88"></a>		return FALSE;
<a name="line89"></a>	}
<a name="line90"></a>
<a name="line91"></a>	/** Setter by reference method.
<a name="line92"></a>	 *
<a name="line93"></a>	 * @param str member Name of the member to set
<a name="line94"></a>	 * @param mixed value The value to set member to
<a name="line95"></a>	 * @return bool
<a name="line96"></a>	 */
<a name="line97"></a>	function setByRef($member, &$value)
<a name="line98"></a>    {
<a name="line99"></a>		$member = '_'.$member;
<a name="line100"></a>		$members = get_object_vars($this);
<a name="line101"></a>		if (array_key_exists($member, $members)) {
<a name="line102"></a>			if (is_array($this->$member)) {
<a name="line103"></a>				$this->{$member}[] =& $value;
<a name="line104"></a>			} else {
<a name="line105"></a>				$this->$member =& $value;
<a name="line106"></a>			}
<a name="line107"></a>			return TRUE;
<a name="line108"></a>		}
<a name="line109"></a>		return FALSE;
<a name="line110"></a>	}
<a name="line111"></a>
<a name="line112"></a>	/** Return the name of this doc item.
<a name="line113"></a>	 *
<a name="line114"></a>	 * @return str
<a name="line115"></a>	 */
<a name="line116"></a>	function name()
<a name="line117"></a>    {
<a name="line118"></a>		return $this->_name;
<a name="line119"></a>	}
<a name="line120"></a>    
<a name="line121"></a>	/** Return tags of the specified kind in this Doc item. For example, if
<a name="line122"></a>	 * 'tagName' has value "@serial", all tags in this Doc item of type "@serial"
<a name="line123"></a>	 * will be returned. If NULL is given for 'tagName', all tags in this Doc
<a name="line124"></a>	 * item are returned.
<a name="line125"></a>	 *
<a name="line126"></a>	 * @param str tagName Name of the tag kind to search for
<a name="line127"></a>	 * @return Tag[] An array of Tag containing all tags of name 'tagname' or a
<a name="line128"></a>	 * singular tag object if only one exists for the given 'tagname'
<a name="line129"></a>	 */
<a name="line130"></a>	function &tags($tagName = NULL)
<a name="line131"></a>    {
<a name="line132"></a>        $return = NULL;
<a name="line133"></a>		if ($tagName == NULL) {
<a name="line134"></a>			$return =& $this->_tags;
<a name="line135"></a>		} elseif (isset($this->_tags[$tagName])) {
<a name="line136"></a>			$return =& $this->_tags[$tagName];
<a name="line137"></a>		}
<a name="line138"></a>		return $return;
<a name="line139"></a>	}
<a name="line140"></a>    
<a name="line141"></a>	/** Set a tag.
<a name="line142"></a>	 *
<a name="line143"></a>	 * @param str tagName Name of the tag kind to search for
<a name="line144"></a>	 * @param Tag tag The tag to set
<a name="line145"></a>	 */
<a name="line146"></a>	function setTag($tagName, $tag)
<a name="line147"></a>    {
<a name="line148"></a>        $this->_tags[$tagName] =& $tag;
<a name="line149"></a>	}
<a name="line150"></a>	
<a name="line151"></a>	/** Return the full unprocessed text of the comment.
<a name="line152"></a>	 *
<a name="line153"></a>	 * @return str
<a name="line154"></a>	 */
<a name="line155"></a>	function getRawCommentText()
<a name="line156"></a>    {
<a name="line157"></a>		return $this->_docComment;
<a name="line158"></a>	}
<a name="line159"></a>
<a name="line160"></a>	/** Is this construct a class. Note: interfaces are not classes. False until
<a name="line161"></a>	 * overridden.
<a name="line162"></a>	 *
<a name="line163"></a>	 * @return bool
<a name="line164"></a>	 */
<a name="line165"></a>	function isClass()
<a name="line166"></a>    {
<a name="line167"></a>		return FALSE;
<a name="line168"></a>	}
<a name="line169"></a>
<a name="line170"></a>	/** Is this construct a constructor. False until overridden.
<a name="line171"></a>	 *
<a name="line172"></a>	 * @return bool
<a name="line173"></a>	 */
<a name="line174"></a>	function isConstructor()
<a name="line175"></a>    {
<a name="line176"></a>		return FALSE;
<a name="line177"></a>	}
<a name="line178"></a>	
<a name="line179"></a>	/** Is this construct an exception. False until overridden.
<a name="line180"></a>	 *
<a name="line181"></a>	 * @return bool
<a name="line182"></a>	 */
<a name="line183"></a>	function isException()
<a name="line184"></a>    {
<a name="line185"></a>		return FALSE;
<a name="line186"></a>	}
<a name="line187"></a>	
<a name="line188"></a>	/** Is this construct a global variable. False until overridden.
<a name="line189"></a>	 *
<a name="line190"></a>	 * @return bool
<a name="line191"></a>	 */
<a name="line192"></a>	function isGlobal()
<a name="line193"></a>    {
<a name="line194"></a>		return FALSE;
<a name="line195"></a>	}
<a name="line196"></a>	
<a name="line197"></a>	/** Is this construct final. False until overridden.
<a name="line198"></a>	 *
<a name="line199"></a>	 * @return bool
<a name="line200"></a>	 */
<a name="line201"></a>	function isFinal()
<a name="line202"></a>    {
<a name="line203"></a>		return FALSE;
<a name="line204"></a>	}
<a name="line205"></a>
<a name="line206"></a>	/** Is this construct a field. False until overridden.
<a name="line207"></a>	 *
<a name="line208"></a>	 * @return bool
<a name="line209"></a>	 */
<a name="line210"></a>	function isField()
<a name="line211"></a>    {
<a name="line212"></a>		return FALSE;
<a name="line213"></a>	}
<a name="line214"></a>
<a name="line215"></a>	/** Is this construct a function. False until overridden.
<a name="line216"></a>	 *
<a name="line217"></a>	 * @return bool
<a name="line218"></a>	 */
<a name="line219"></a>	function isFunction()
<a name="line220"></a>    {
<a name="line221"></a>		return FALSE;
<a name="line222"></a>	}
<a name="line223"></a>	
<a name="line224"></a>	/** Is this construct an interface. False until overridden.
<a name="line225"></a>	 *
<a name="line226"></a>	 * @return bool
<a name="line227"></a>	 */
<a name="line228"></a>	function isInterface()
<a name="line229"></a>    {
<a name="line230"></a>		return FALSE;
<a name="line231"></a>	}
<a name="line232"></a>	
<a name="line233"></a>	/** Is this construct a method. False until overridden.
<a name="line234"></a>	 *
<a name="line235"></a>	 * @return bool
<a name="line236"></a>	 */
<a name="line237"></a>	function isMethod()
<a name="line238"></a>    {
<a name="line239"></a>		return FALSE;
<a name="line240"></a>	}
<a name="line241"></a>	
<a name="line242"></a>	/** Is this construct an ordinary class (not an interface or an exception).
<a name="line243"></a>	 * False until overridden.
<a name="line244"></a>	 *
<a name="line245"></a>	 * @return bool
<a name="line246"></a>	 */
<a name="line247"></a>	function isOrdinaryClass()
<a name="line248"></a>    {
<a name="line249"></a>		return FALSE;
<a name="line250"></a>	}
<a name="line251"></a>	
<a name="line252"></a>	/** Merge the contents of the doc comment into the element object. */
<a name="line253"></a>	function mergeData()
<a name="line254"></a>    {
<a name="line255"></a>		if (isset($this->_data) && is_array($this->_data)) {
<a name="line256"></a>			// merge primitive types
<a name="line257"></a>			foreach ($this->_data as $member => $value) {
<a name="line258"></a>				if (!is_array($value)) {
<a name="line259"></a>					if ($member == 'type') {
<a name="line260"></a>						$this->set('type', new type($value, $this->_root));
<a name="line261"></a>					} else {
<a name="line262"></a>						$this->set($member, $value);
<a name="line263"></a>					}
<a name="line264"></a>				}
<a name="line265"></a>			}
<a name="line266"></a>			// merge tags array
<a name="line267"></a>			if (isset($this->_data['tags']) && is_array($this->_data['tags'])) {
<a name="line268"></a>				$thisClass = strtolower(get_class($this));
<a name="line269"></a>				foreach ($this->_data['tags'] as $name => $tag) {
<a name="line270"></a>					if (is_array($tag)) {
<a name="line271"></a>						foreach ($this->_data['tags'][$name] as $key => $tag) {
<a name="line272"></a>							if (
<a name="line273"></a>								($thisClass == 'rootdoc' && $this->_data['tags'][$name][$key]->inOverview()) ||
<a name="line274"></a>								($thisClass == 'packagedoc' && $this->_data['tags'][$name][$key]->inPackage()) ||
<a name="line275"></a>								($thisClass == 'classdoc' && $this->_data['tags'][$name][$key]->inType()) ||
<a name="line276"></a>								($thisClass == 'methoddoc' && $this->_data['tags'][$name][$key]->inMethod()) ||
<a name="line277"></a>								($thisClass == 'fielddoc' && $this->_data['tags'][$name][$key]->inField())
<a name="line278"></a>							) {
<a name="line279"></a>								$this->_tags[$name][$key] =& $this->_data['tags'][$name][$key];
<a name="line280"></a>								$this->_tags[$name][$key]->setParent($this);
<a name="line281"></a>							}
<a name="line282"></a>						}
<a name="line283"></a>					} else {
<a name="line284"></a>						if (
<a name="line285"></a>							($thisClass == 'rootdoc' && $this->_data['tags'][$name]->inOverview()) ||
<a name="line286"></a>							($thisClass == 'packagedoc' && $this->_data['tags'][$name]->inPackage()) ||
<a name="line287"></a>							($thisClass == 'classdoc' && $this->_data['tags'][$name]->inType()) ||
<a name="line288"></a>							($thisClass == 'methoddoc' && $this->_data['tags'][$name]->inMethod()) ||
<a name="line289"></a>							($thisClass == 'fielddoc' && $this->_data['tags'][$name]->inField())
<a name="line290"></a>						) {
<a name="line291"></a>							$this->_tags[$name] =& $this->_data['tags'][$name];
<a name="line292"></a>							$this->_tags[$name]->setParent($this);
<a name="line293"></a>						}
<a name="line294"></a>					}
<a name="line295"></a>				}
<a name="line296"></a>			}
<a name="line297"></a>			// merge parameter types
<a name="line298"></a>			if (isset($this->_parameters) && isset($this->_data['parameters'])) {
<a name="line299"></a>				foreach($this->_data['parameters'] as $name => $param) {
<a name="line300"></a>				    if (substr($name, 0, 9) == '__unknown') {
<a name="line301"></a>                        $index = substr($name, 9);
<a name="line302"></a>                        $parameters = array_values($this->_parameters);
<a name="line303"></a>                        if (isset($parameters[$index])) {
<a name="line304"></a>                            $parameters[$index]->set('type', new type($param['type'], $this->_root));
<a name="line305"></a>                        }
<a name="line306"></a>				    } else {
<a name="line307"></a>                        if (!isset($this->_parameters[$name])) {
<a name="line308"></a>                            //phpdoctor::warning('Unknown parameter "'.$name.'" found for method "'.$this->_package.'.'.$this->_parent->name().'::'.$this->_name.'".');
<a name="line309"></a>                            $this->_parameters[$name] =& new fieldDoc($name, $this, $this->_root);
<a name="line310"></a>                            if (isset($this->_package)) $this->_parameters[$name]->set('package', $this->_package);
<a name="line311"></a>                        }
<a name="line312"></a>                        $this->_parameters[$name]->set('type', new type($param['type'], $this->_root));
<a name="line313"></a>                    }
<a name="line314"></a>				}
<a name="line315"></a>			}
<a name="line316"></a>			// merge return type
<a name="line317"></a>			if (isset($this->_returnType) && isset($this->_data['return'])) {
<a name="line318"></a>				$this->_returnType =& new type($this->_data['return'], $this->_root);
<a name="line319"></a>			}
<a name="line320"></a>			// merge exceptions
<a name="line321"></a>			if (isset($this->_throws) && isset($this->_data['throws'])) {
<a name="line322"></a>				foreach($this->_data['throws'] as $name => $exception) {
<a name="line323"></a>					$this->_throws[$name] =& $this->_data['throws'][$name];
<a name="line324"></a>				}
<a name="line325"></a>			}
<a name="line326"></a>		}
<a name="line327"></a>		// remove data array since we no longer need it
<a name="line328"></a>		#unset($this->_data);
<a name="line329"></a>	}
<a name="line330"></a>
<a name="line331"></a>	/**
<a name="line332"></a>	 * Get body of a HTML document
<a name="line333"></a>	 *
<a name="line334"></a>	 * @param str filename
<a name="line335"></a>	 * @return str
<a name="line336"></a>	 */
<a name="line337"></a>	function getHTMLContents($filename)
<a name="line338"></a>    {
<a name="line339"></a>			if ($contents = file_get_contents($filename)) {
<a name="line340"></a>				if (preg_match('/<body ?.*?>(.+)<\/body>/s', $contents, $matches)) {
<a name="line341"></a>					return $matches[1];
<a name="line342"></a>				} else { // it's not HTML, so output it as plain text
<a name="line343"></a>                    return '<pre>'.$contents.'</pre>';
<a name="line344"></a>                }
<a name="line345"></a>			}
<a name="line346"></a>			return FALSE;
<a name="line347"></a>	}
<a name="line348"></a>
<a name="line349"></a>}
<a name="line350"></a>
<a name="line351"></a>?>
<a name="line352"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/doc.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>